%  Copyright (C) 2003 David Roundy
%
%  This program is free software; you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation; either version 2, or (at your option)
%  any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program; if not, write to the Free Software Foundation,
%  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
\begin{code}
module TheCommands ( the_commands ) where

import DarcsCommands ( DarcsCommand )
import Init ( initialize )
import Add ( add )
import Remove ( remove )
import WhatsNew ( whatsnew )
import Record ( record )
import Unrecord ( unrecord, unpull )
import Check ( check )
import Revert ( revert )
import Get ( get )
import Pull ( pull )
import Dist ( dist )
import Mv ( mv )
import Replace ( replace )
import Tag ( tag )
import Push ( push )
import Send ( send )
import Apply ( apply )
import DiffCommand
import SetPref ( setpref )
import Changes ( changes )
import Unrevert ( unrevert )
import TrackDown ( trackdown )
import Optimize ( optimize )
import Rollback ( rollback )
import Annotate ( annotate )
import Repair ( repair )

the_commands :: [DarcsCommand]
the_commands = [initialize, get,
                add, remove, mv,
                whatsnew, record, unrecord, revert, unrevert, pull, unpull, rollback,
                send, apply, push,
                replace, tag, setpref,
                diff_command,
                changes, annotate,
                optimize,
                check,
                dist, trackdown, repair
               ]
\end{code}

